Imports System.Math
Public Class Form1

    Private Structure StoneStructure
        Dim X, Y As Double
        Dim Vx, Vy As Double
        Dim IsOnSheet As Boolean
        Dim Color As StoneColor
    End Structure

    Private Enum StoneColor
        Red = 0
        Yellow = 1
    End Enum

    'P[kgf,m,msec]
    Const m As Integer = 20 'Xg[
    Dim mu As Double 'CW
    Const mu1 As Double = 0.025 'uVȂ
    Const mu2 As Double = 0.015 'uV
    Const nu As Double = 0.7 'Xg[O㎿ʔ(/O)
    Const nu2 As Double = (1 - nu) / (1 + nu)
    Const coeE As Double = 0.97 'W
    Const g As Double = 9.80665 / 10 ^ 6 'd͉x
    Const dTr As Double = PI / 180

    Const SheetWidth As Single = 4.75
    Const SheetHeight As Single = 44.5
    Const CenterToCenter As Single = 34.75
    Const FogToFog As Single = 21.95
    Const FogToCenter As Single = 6.4
    Const EndLine As Single = 3.045
    Const Hack As Single = 3.66
    Const HouseRadius1 As Single = 0.15
    Const HouseRadius2 As Single = 0.61
    Const HouseRadius3 As Single = 1.22
    Const HouseRadius4 As Single = 1.83
    Dim HouseOffset As PointF = New PointF(SheetWidth / 2, SheetHeight - HouseRadius4 - EndLine)
    Const StoneRadius As Single = 0.15
    Const StoneColorRadius As Single = 0.1

    Dim Stone(15) As StoneStructure
    Dim NowStoneIndex As Integer
    Dim NowEndIndex As Integer
    Dim FreeStone(3) As StoneStructure
    Dim FreeRule(3) As Boolean

    Const TimeStep As Integer = 10
    Dim NowTime As Integer
    Dim CaseNum As Integer
    Dim Impact As Boolean

    Dim StoneLocus(), StoneLocus3D() As PointF
    Dim RedBrushImage, YellowBrushImage As Image
    Dim IsBrush As Boolean
    Dim ArrowPoint, BrushPoint, PicAllMousePoint As Point

    Dim RedScore(9) As Integer, YellowScore(9) As Integer
    Dim RedTotal As Integer, YellowTotal As Integer
    Dim PicAllViewRatio, PicHouseRatio, Pic3DRatio As Double

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        For i As Integer = 0 To UBound(Stone)
            With Stone(i)
                .X = 0
                .Y = 0
                .Vx = 0
                .Vy = 0
                .IsOnSheet = False
                .Color = i Mod 2
            End With
        Next i
        mu = mu1

        Dim RedBrushPath As String = Application.StartupPath & "\RedBrush.ico"
        Dim YellowBrushPath As String = Application.StartupPath & "\YellowBrush.ico"

        If Dir(RedBrushPath) = "" Then GoTo 100
        If Dir(YellowBrushPath) = "" Then GoTo 100

        RedBrushImage = Image.FromFile(Application.StartupPath & "\RedBrush.ico")
        YellowBrushImage = Image.FromFile(Application.StartupPath & "\YellowBrush.ico")
        RedBrushImage.RotateFlip(RotateFlipType.RotateNoneFlipY)
        YellowBrushImage.RotateFlip(RotateFlipType.RotateNoneFlipY)
100:
        Timer1.Interval = TimeStep
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        With PicAllView
            .Width = CInt(.Height * (SheetWidth / SheetHeight))
            PicAllViewRatio = .Width / SheetWidth
            .Invalidate()
        End With
        With PicHouse
            .Width = CInt(.Height * (SheetWidth / ((SheetHeight - FogToFog) / 2)))
            PicHouseRatio = .Width / SheetWidth
            .Invalidate()
        End With
        With Pic3D
            Pic3DRatio = .Width / SheetWidth
            .Invalidate()
        End With
    End Sub

    Private Sub PicAllView_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PicAllView.MouseDown
        If CaseNum = 0 Then
            If e.Button = Windows.Forms.MouseButtons.Left Then
                Dim StartPoint As PointF
                StartPoint.X = e.X / PicAllViewRatio - HouseOffset.X
                StartPoint.Y = -(e.Y / PicAllViewRatio - HouseOffset.Y)

                With Stone(NowStoneIndex)
                    If StartPoint.Y > FogToCenter + FogToFog Then
                        .Vx = StartPoint.X / 1000
                        .Vy = (StartPoint.Y - (Hack + CenterToCenter)) / 1000
                        .X = ((Hack + FogToCenter) * StartPoint.X) / ((Hack + CenterToCenter) - StartPoint.Y)
                    Else
                        .Vx = (((Hack + FogToCenter) * StartPoint.X) / ((Hack + CenterToCenter) - StartPoint.Y)) / 1000
                        .Vy = -(Hack + FogToCenter) / 1000
                        .X = ((Hack + FogToCenter) * StartPoint.X) / ((Hack + CenterToCenter) - StartPoint.Y)
                    End If
                    '.Vx = 0
                    '.Vy = -0.0035
                    '.X = 1
                    .Y = FogToCenter + FogToFog
                    .IsOnSheet = True
                End With
                grpStoneSpin.Enabled = False
                CaseNum = 1
                Timer1.Enabled = True
            End If
        End If
    End Sub

    Private Sub PicAllView_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PicAllView.MouseMove
        Select Case CaseNum
            Case 0
                With ArrowPoint
                    .X = e.X - HouseOffset.X * PicAllViewRatio
                    .Y = -e.Y + HouseOffset.Y * PicAllViewRatio
                End With
                PicAllView.Invalidate()
            Case 1
                If e.Button = Windows.Forms.MouseButtons.Left Then
                    PicAllMousePoint = e.Location
                Else
                    PicAllMousePoint = New Point(0, 0)
                End If
        End Select
    End Sub

    Private Sub PicAllView_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PicAllView.MouseUp
        If CaseNum = 1 Then
            PicAllMousePoint = New Point(0, 0)
        End If
    End Sub

    Private Sub PicAllView_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PicAllView.Paint
        PicTranslate(e.Graphics, HouseOffset.X, HouseOffset.Y, PicAllViewRatio)
        DrawSheet(e.Graphics, PicAllViewRatio)
        If NowStoneIndex = 16 Then Exit Sub
        For i As Integer = 0 To NowStoneIndex
            With Stone(i)
                If .IsOnSheet = True Then
                    DrawStone(e.Graphics, .X, .Y, PicAllViewRatio, .Color)
                End If
            End With
        Next i

        Select Case CaseNum
            Case 0
                Dim ArrowPen As New Pen(Color.Lime)
                With ArrowPen
                    .Width = 5
                    .EndCap = Drawing2D.LineCap.ArrowAnchor
                End With
                e.Graphics.DrawLine(ArrowPen, New Point(0, (CenterToCenter + Hack) * PicAllViewRatio), ArrowPoint)
            Case 1
                If StoneLocus IsNot Nothing AndAlso UBound(StoneLocus) <> 0 Then
                    e.Graphics.DrawLines(Pens.Black, StoneLocus)
                End If
        End Select


        If RedBrushImage IsNot Nothing AndAlso YellowBrushImage IsNot Nothing Then
            Dim BrushArea As RectangleF
            With Stone(NowStoneIndex)
                BrushArea = New RectangleF(.X - 2 * StoneRadius, .Y - 6 * StoneRadius, 4 * StoneRadius, 6 * StoneRadius)
            End With
            Dim MousePoint As PointF
            MousePoint.X = PicAllMousePoint.X / PicAllViewRatio - HouseOffset.X
            MousePoint.Y = -(PicAllMousePoint.Y / PicAllViewRatio - HouseOffset.Y)
            If BrushArea.Contains(MousePoint) = True Then
                mu = mu2
                BrushPoint.X = PicAllMousePoint.X - HouseOffset.X * PicAllViewRatio - 16
                BrushPoint.Y = -PicAllMousePoint.Y + HouseOffset.Y * PicAllViewRatio - 16
                Select Case Stone(NowStoneIndex).Color
                    Case StoneColor.Red
                        e.Graphics.DrawImage(RedBrushImage, BrushPoint)
                    Case StoneColor.Yellow
                        e.Graphics.DrawImage(YellowBrushImage, BrushPoint)
                End Select
            Else
                mu = mu1
            End If
        End If

    End Sub

    Private Sub PicHouse_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PicHouse.Paint
        PicTranslate(e.Graphics, HouseOffset.X, FogToCenter + 1, PicHouseRatio)
        DrawSheet(e.Graphics, PicHouseRatio)
        If NowStoneIndex = 16 Then Exit Sub
        For i As Integer = 0 To NowStoneIndex
            With Stone(i)
                If .IsOnSheet = True Then
                    DrawStone(e.Graphics, .X, .Y, PicHouseRatio, .Color)
                End If
            End With
        Next i
    End Sub

    Private Sub Pic3D_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Pic3D.Paint
        PicScaling(Pic3D, e.Graphics, HouseOffset.X * Pic3DRatio, _
                                    -(HouseRadius4 + EndLine) * Pic3DRatio, _
                                    -HouseOffset.X * Pic3DRatio, _
                                    (FogToCenter + FogToFog) * Pic3DRatio)
        DrawSheet(e.Graphics, Pic3DRatio)
        If CaseNum = 1 AndAlso StoneLocus3D IsNot Nothing AndAlso UBound(StoneLocus3D) <> 0 Then
            e.Graphics.DrawLines(Pens.Black, StoneLocus3D)
        End If

        If NowStoneIndex = 16 Then Exit Sub
        Dim Stone3D() As StoneStructure = Nothing
        Dim ArrY() As Double = Nothing
        Dim Stone3DNum As Integer
        For i As Integer = 0 To NowStoneIndex
            With Stone(i)
                If .IsOnSheet = True Then
                    ReDim Preserve Stone3D(Stone3DNum), ArrY(Stone3DNum)
                    Stone3D(Stone3DNum) = Stone(i)
                    ArrY(Stone3DNum) = .Y
                    Stone3DNum += 1
                End If
            End With
        Next i
        If Stone3DNum = 0 Then Exit Sub
        Array.Sort(ArrY, Stone3D)
        For i As Integer = 0 To UBound(Stone3D)
            With Stone3D(i)
                DrawStone3D(e.Graphics, .X, .Y, .Color)
            End With
        Next i
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        CalStone()
        PicAllView.Invalidate()
        PicHouse.Invalidate()
        Pic3D.Invalidate()
        'Debug.Print(mu)
    End Sub

    Private Sub CalStone()
        Dim StoneDistance As Double
        Dim VectorAngle As Double

        NowTime += 1
        ReDim Preserve StoneLocus(NowTime - 1), StoneLocus3D(NowTime - 1)

        With Stone(NowStoneIndex)
            .X += .Vx * TimeStep
            .Y += .Vy * TimeStep

            StoneLocus(NowTime - 1).X = .X * PicAllViewRatio
            StoneLocus(NowTime - 1).Y = .Y * PicAllViewRatio
            StoneLocus3D(NowTime - 1).X = .X * Pic3DRatio
            StoneLocus3D(NowTime - 1).Y = .Y * Pic3DRatio

            'ǂɏՓ
            If Abs(.X) > (SheetWidth / 2 - StoneRadius) Then
                .Vx = 0
                .Vy = 0
                .IsOnSheet = False
                GoTo 30
            End If
            If .Y < -Hack Then
                .Vx = 0
                .Vy = 0
                .IsOnSheet = False
                GoTo 30
            End If

            'Xg[Փ
            For i As Integer = 0 To UBound(Stone)
                If Stone(i).IsOnSheet = True Then
                    If i <> NowStoneIndex Then
                        StoneDistance = Sqrt((.X - Stone(i).X) ^ 2 + (.Y - Stone(i).Y) ^ 2)
                        If StoneDistance < 2 * StoneRadius Then
                            fImpact(Stone(NowStoneIndex), Stone(i), StoneDistance)
                            Impact = True
                        End If
                    End If
                End If
            Next i
30:
            If Impact = True Then fImpact2()

            'xZo
            If .Vx = 0 Then
                If .Vy = 0 Then GoTo 200
                VectorAngle = 270 * dTr
                GoTo 50
            End If
            VectorAngle = Atan2(.Vy, .Vx)
            'If NowVx < 0 Then VectorAngle = VectorAngle + PI
50:
            Select Case True
                Case rdbClockSpin.Checked
                    .Vx -= mu * g * (Cos(VectorAngle) + nu2) * TimeStep
                Case rdbReverseSpin.Checked
                    .Vx -= mu * g * (Cos(VectorAngle) - nu2) * TimeStep
            End Select
100:
            .Vy -= mu * g * Sin(VectorAngle) * TimeStep
200:
        End With
        StoneStop()

    End Sub

    Private Sub fImpact(ByRef Stone1 As StoneStructure, ByRef Stone2 As StoneStructure, ByVal Distance As Double)

        Dim V1 As Double
        Dim Th1 As Double, Th2 As Double, Alp1 As Double
        Dim A1 As Double, A2 As Double
        Dim Z As Double

        V1 = Sqrt(Stone1.Vx ^ 2 + Stone1.Vy ^ 2)

        If Stone1.Vx = 0 Then
            Th1 = 270 * dTr
            GoTo 100
        End If
        Th1 = Atan2(Stone1.Vy, Stone1.Vx)
        'If V1x < 0 Then Th1 = Th1 + Pi
100:
        If (Stone2.X - Stone1.X) = 0 Then
            Th2 = 270 * dTr
            GoTo 200
        End If

        Th2 = Atan2((Stone2.Y - Stone1.Y), (Stone2.X - Stone1.X))
        If (Stone2.X - Stone1.X) < 0 Then
            rdbClockSpin.Checked = True
        Else
            rdbReverseSpin.Checked = True
        End If
200:
        A1 = V1 * Sin(Th1 - Th2)
        A2 = (coeE - 1) * V1 * Cos(Th1 - Th2) / 2

        If A2 = 0 Then
            Alp1 = PI / 2
            GoTo 300
        End If
        Alp1 = Atan2(A1, A2)
        'If A2 < 0 Then Alp1 = Alp1 + PI
300:
        Stone2.Vx = (1 + coeE) * V1 * Cos(Th2) * Cos(Th1 - Th2) / 2
        Stone2.Vy = (1 + coeE) * V1 * Sin(Th2) * Cos(Th1 - Th2) / 2

        V1 = Sqrt(A1 ^ 2 + A2 ^ 2)

        Stone1.Vx = V1 * Cos(Th2 - Alp1 + PI)
        Stone1.Vy = V1 * Sin(Th2 - Alp1 + PI)

        Z = -Distance * Cos(Th2 - Th1) + Sqrt(0.09 - (Distance * Sin(Th2 - Th1)) ^ 2)
        Stone1.X -= Z * Cos(Th1)
        Stone1.Y -= Z * Sin(Th1)

    End Sub

    Private Sub fImpact2()
        Dim StoneDistance As Double
        Dim VectorAngle As Double

        For i As Integer = 0 To NowStoneIndex
            With Stone(i)
                If .IsOnSheet = True Then
                    .X += .Vx * TimeStep
                    .Y += .Vy * TimeStep

                    'ǂɏՓ
                    If Abs(.X) > (SheetWidth / 2 - StoneRadius) OrElse .Y < -Hack Then
                        .Vx = 0
                        .Vy = 0
                        .IsOnSheet = False
                        If NowStoneIndex <= 3 Then
                            If i <> NowStoneIndex Then
                                If FreeRule(i) = True Then
                                    .X = FreeStone(i).X
                                    .Y = FreeStone(i).Y
                                    .IsOnSheet = True
                                    GoTo 200
                                End If
                            End If
                        End If
                    End If

                    'Xg[Փ
                    For j As Integer = 0 To UBound(Stone)
                        If Stone(j).IsOnSheet = True Then
                            If j <> i Then
                                StoneDistance = Sqrt((.X - Stone(j).X) ^ 2 + (.Y - Stone(j).Y) ^ 2)
                                If StoneDistance < 2 * StoneRadius Then
                                    fImpact(Stone(i), Stone(j), StoneDistance)
                                End If
                            End If
                        End If
                    Next j

                    'xZo
                    If .Vx = 0 Then
                        If .Vy = 0 Then GoTo 200
                        VectorAngle = 270 * dTr
                        GoTo 50
                    End If
                    VectorAngle = Atan2(.Vy, .Vx)
                    'If .Vx < 0 Then CrashAngle += PI
50:
                    Select Case True
                        Case rdbClockSpin.Checked
                            .Vx -= mu * g * (Cos(VectorAngle) + nu2) * TimeStep
                        Case rdbReverseSpin.Checked
                            .Vx -= mu * g * (Cos(VectorAngle) - nu2) * TimeStep
                    End Select
                    .Vy -= mu * g * Sin(VectorAngle) * TimeStep
200:
                End If
            End With
        Next i

    End Sub

    Private Sub StoneStop()
        Dim MinimumVelocity As Double = 0.000003

        For i As Integer = 0 To NowStoneIndex
            With Stone(i)
                If .IsOnSheet = True Then
                    If Abs(.Vx) > MinimumVelocity Then Exit Sub
                    If Abs(.Vy) > MinimumVelocity Then Exit Sub
                End If
            End With
        Next i

        Timer1.Enabled = False
        PicAllView.Enabled = True
        grpStoneSpin.Enabled = True
        NextStone()
    End Sub

    Private Sub NextStone()
        Dim Distance As Double

        With Stone(NowStoneIndex)
            If .Y > 6.4 Then .IsOnSheet = False
            If NowStoneIndex <= 3 Then
                Distance = Sqrt(.X ^ 2 + .Y ^ 2)
                If Distance > (HouseRadius4 + StoneRadius) AndAlso .Y > 0 Then
                    FreeRule(NowStoneIndex) = True
                    FreeStone(NowStoneIndex) = Stone(NowStoneIndex)
                End If
            End If

            Impact = False
            IsBrush = False
            ReDim StoneLocus(0), StoneLocus3D(0)
            NowTime = 0
            CaseNum = 0

            NowStoneIndex += 1
            If NowStoneIndex = UBound(Stone) + 1 Then
                EndEnd()
                Exit Sub
            End If
        End With

        Select Case Stone(NowStoneIndex - 1).Color
            Case StoneColor.Red
                Stone(NowStoneIndex).Color = StoneColor.Yellow
                lblRedRemain.Text = Strings.Left(lblRedRemain.Text, lblRedRemain.Text.Length - 1)
                lblRedStone.Text = ""
                lblYellowStone.Text = "l"
            Case StoneColor.Yellow
                Stone(NowStoneIndex).Color = StoneColor.Red
                lblYellowRemain.Text = Strings.Left(lblYellowRemain.Text, lblYellowRemain.Text.Length - 1)
                lblRedStone.Text = "l"
                lblYellowStone.Text = ""
        End Select

        If Stone(NowStoneIndex).Color = StoneColor.Red AndAlso txtName1.Text = "com" Then
            ComputerDraw()
        ElseIf Stone(NowStoneIndex).Color = StoneColor.Yellow AndAlso txtName2.Text = "com" Then
            ComputerDraw()
        End If

    End Sub

    Private Sub EndEnd()
        Dim Distance(UBound(Stone)) As Double
        Dim DistanceColor(UBound(Stone)) As StoneColor
        Dim Order(UBound(Stone)) As Integer

        'S̋Zo
        For i As Integer = 0 To UBound(Stone)
            With Stone(i)
                Distance(i) = 2 * HouseRadius4
                If .IsOnSheet = True Then
                    Distance(i) = Sqrt(.X ^ 2 + .Y ^ 2)
                    DistanceColor(i) = .Color
                End If
            End With
        Next i
        Array.Sort(Distance, DistanceColor)

        '_Zo
        For i As Integer = 0 To UBound(Stone)
            If Distance(i) > HouseRadius4 + StoneRadius Then Exit For
            If DistanceColor(i) <> DistanceColor(0) Then Exit For
            Select Case DistanceColor(i)
                Case StoneColor.Red
                    RedScore(NowEndIndex) += 1
                Case StoneColor.Yellow
                    YellowScore(NowEndIndex) += 1
            End Select
        Next i

        RedTotal += RedScore(NowEndIndex)
        YellowTotal += YellowScore(NowEndIndex)

        Dim lblName As String
        lblName = "lblRedScore" & NowEndIndex + 1
        tblScore.Controls(lblName).Text = RedScore(NowEndIndex)
        lblName = "lblYellowScore" & NowEndIndex + 1
        tblScore.Controls(lblName).Text = YellowScore(NowEndIndex)
        lblRedScoreTotal.Text = RedTotal
        lblYellowScoreTotal.Text = YellowTotal

        If RedScore(NowEndIndex) > YellowScore(NowEndIndex) Then
            MsgBox(txtName1.Text & "" & RedScore(NowEndIndex) & "_lłB", , NowEndIndex + 1 & "th End IłB")
            Stone(0).Color = StoneColor.Red
        ElseIf RedScore(NowEndIndex) < YellowScore(NowEndIndex) Then
            MsgBox(txtName2.Text & "" & YellowScore(NowEndIndex) & "_lłB", , NowEndIndex + 1 & "th End IłB")
            Stone(0).Color = StoneColor.Yellow
        Else
            MsgBox("łB", , NowEndIndex + 1 & "th End IłB")
            Stone(0).Color = Stone(UBound(Stone)).Color
        End If

        For i As Integer = 0 To UBound(Stone)
            With Stone(i)
                .X = 0
                .Y = 0
                .Vx = 0
                .Vy = 0
                .IsOnSheet = False
            End With
        Next i
        NowStoneIndex = 0
        NowEndIndex += 1
        lblRedRemain.Text = "llllllll"
        lblYellowRemain.Text = "llllllll"

        If NowEndIndex = 10 Then
            If RedTotal > YellowTotal Then
                MsgBox(RedTotal & "" & YellowTotal & "" & txtName1.Text & "̏łB", , "Q[I")
            ElseIf RedTotal < YellowTotal Then
                MsgBox(YellowTotal & "" & RedTotal & "" & txtName2.Text & "̏łB", , "Q[I")
            Else
                MsgBox(RedTotal & "" & YellowTotal & "̈łB", , "Q[I")
            End If
            CaseNum = 2
        End If
    End Sub

    Private Sub ComputerDraw()
        Dim X As Single
        Dim Y As Single
        Dim Roll As Integer '0:v,1:v
        Dim StayStoneNum As Integer
        Dim HouseInNum As Integer
        Dim HouseInStone() As StoneStructure = Nothing
        Dim Distance As Double
        Dim ComColor As StoneColor
        Dim CenterG As Boolean, RightCornerG As Boolean, LeftCornerG As Boolean
        Dim BlueIn As Boolean, RightIn As Boolean, LeftIn As Boolean

        mu = mu1
        ComColor = Stone(NowStoneIndex).Color

        For i As Integer = 0 To NowStoneIndex - 1
            With Stone(i)
                If .IsOnSheet = True Then
                    StayStoneNum += 1
                    Distance = Sqrt(.X ^ 2 + Y ^ 2)
                    If Distance <= HouseRadius4 + StoneRadius Then
                        ReDim Preserve HouseInStone(HouseInNum)
                        HouseInStone(HouseInNum) = Stone(i)
                        HouseInNum += 1
                        If Distance <= HouseRadius2 + StoneRadius Then
                            BlueIn = True
                        ElseIf .X >= 0 Then
                            RightIn = True
                        ElseIf .X < 0 Then
                            LeftIn = True
                        End If
                    End If
                    If .Y > HouseRadius3 Then
                        If Abs(.X) <= HouseRadius2 + StoneRadius Then
                            CenterG = True
                        ElseIf HouseRadius2 + StoneRadius < .X AndAlso .X < HouseRadius4 + StoneRadius Then
                            RightCornerG = True
                        ElseIf -HouseRadius4 + StoneRadius < .X AndAlso .X < -HouseRadius2 + StoneRadius Then
                            LeftCornerG = True
                        End If
                    End If
                End If
            End With
        Next i

        If StayStoneNum = 0 Then
            X = 0.2035
            Y = 34.94
            Roll = 2
            GoTo 500
        End If

        Select Case CenterG
            Case True
                If RightCornerG = False Then
                    If NowStoneIndex >= 14 Then GoTo 300
                    Select Case RightIn
                        Case True
                            For i As Integer = 0 To HouseInNum
                                With HouseInStone(i)
                                    If .Color = ComColor Then
                                        X = 0.338
                                        Y = 34.94
                                        Roll = 0
                                        GoTo 500
                                    Else
                                        X = .X
                                        Y = .Y
                                        Roll = 0
                                        GoTo 500
                                    End If
                                End With
                            Next i
                        Case False
                            GoTo 300
                    End Select
                ElseIf LeftCornerG = False Then
                    If NowStoneIndex >= 14 Then GoTo 400
                    Select Case LeftIn
                        Case True
                            For i As Integer = 0 To HouseInNum
                                With HouseInStone(i)
                                    If .Color = ComColor Then
                                        X = -0.338
                                        Y = 34.94
                                        Roll = 1
                                        GoTo 500
                                    Else
                                        X = .X
                                        Y = .Y
                                        Roll = 0
                                        GoTo 500
                                    End If
                                End With
                            Next i
                        Case False
                            GoTo 400
                    End Select
                End If
            Case False
                If BlueIn = True Then
                    For i As Integer = 0 To HouseInNum
                        With HouseInStone(i)
                            If .Color = ComColor Then
                                X = 0
                                Y = 34.9
                                Roll = 0
                                GoTo 500
                            Else
                                X = .X
                                Y = .Y
                                Roll = 0
                                GoTo 500
                            End If
                        End With
                    Next i
                End If
                Select Case RightCornerG
                    Case True
                        X = -0.165
                        Y = 34.7
                        Roll = 1
                        GoTo 500
                    Case False
                        If NowStoneIndex >= 14 Then GoTo 300
                        If RightIn = True Then
                            For i As Integer = 0 To HouseInNum
                                With HouseInStone(i)
                                    If .Color = ComColor Then
                                        X = -0.136
                                        Y = 34.94
                                        Roll = 1
                                        GoTo 500
                                    Else
                                        X = .X
                                        Y = .Y
                                        Roll = 0
                                        GoTo 500
                                    End If
                                End With
                            Next i
                        End If
                End Select
                Select Case LeftCornerG
                    Case True
                        X = 0.165
                        Y = 34.7
                        Roll = 0
                        GoTo 500
                    Case False
                        If NowStoneIndex >= 14 Then GoTo 400
                        If RightIn = True Then
                            For i As Integer = 0 To HouseInNum
                                With HouseInStone(i)
                                    If .Color = ComColor Then
                                        X = 0.136
                                        Y = 34.94
                                        Roll = 0
                                        GoTo 500
                                    Else
                                        X = .X
                                        Y = .Y
                                        Roll = 0
                                        GoTo 500
                                    End If
                                End With
                            Next i
                        End If
                End Select
        End Select
300:
        X = 0.245
        Y = 34.69
        Roll = 0
        GoTo 500
400:
        X = -0.245
        Y = 34.69
        Roll = 1
500:
        Select Case Roll
            Case 0
                rdbClockSpin.Checked = True
            Case 1
                rdbReverseSpin.Checked = True
        End Select

        With Stone(NowStoneIndex)
            If Y > FogToCenter + FogToFog Then
                .Vx = X / 1000
                .Vy = (Y - (Hack + CenterToCenter)) / 1000
                .X = ((Hack + FogToCenter) * X) / ((Hack + CenterToCenter) - Y)
            Else
                .Vx = (((Hack + FogToCenter) * X) / ((Hack + CenterToCenter) - Y)) / 1000
                .Vy = -(Hack + FogToCenter) / 1000
                .X = ((Hack + FogToCenter) * X) / ((Hack + CenterToCenter) - Y)
            End If
            .Y = FogToCenter + FogToFog
            .IsOnSheet = True
        End With
        PicAllView.Enabled = False
        grpStoneSpin.Enabled = False
        CaseNum = 1
        Timer1.Enabled = True

    End Sub

    Private Sub DrawSheet(ByVal PicG As Graphics, ByVal Ratio As Single)
        DrawHouse(PicG, New PointF(0, 0), Ratio)
        DrawHouse(PicG, New PointF(0, CenterToCenter), Ratio)
        With PicG
            'Z^[C
            .DrawLine(Pens.Black, 0, -HouseRadius4 * Ratio, _
                                0, (CenterToCenter + HouseRadius4) * Ratio)
            'GhC
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, (CenterToCenter + HouseRadius4) * Ratio, _
                                (SheetWidth / 2) * Ratio, (CenterToCenter + HouseRadius4) * Ratio)
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, -HouseRadius4 * Ratio, _
                                (SheetWidth / 2) * Ratio, -HouseRadius4 * Ratio)
            'eB[C
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, CenterToCenter * Ratio, _
                                (SheetWidth / 2) * Ratio, CenterToCenter * Ratio)
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, 0, (SheetWidth / 2) * Ratio, 0)
            'tHbOC
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, (FogToCenter + FogToFog) * Ratio, _
                                (SheetWidth / 2) * Ratio, (FogToCenter + FogToFog) * Ratio)
            .DrawLine(Pens.Black, (-SheetWidth / 2) * Ratio, FogToCenter * Ratio, _
                                (SheetWidth / 2) * Ratio, FogToCenter * Ratio)
        End With
    End Sub

    Private Sub DrawHouse(ByVal PicG As Graphics, ByVal po As PointF, ByVal Ratio As Single)
        Dim Radius As Single
        Dim Center As PointF
        Center.X = po.X * Ratio
        Center.Y = po.Y * Ratio

        With PicG
            Radius = HouseRadius4 * Ratio
            .FillEllipse(Brushes.Red, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
            Radius = HouseRadius3 * Ratio
            .FillEllipse(Brushes.White, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
            Radius = HouseRadius2 * Ratio
            .FillEllipse(Brushes.Blue, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
            Radius = HouseRadius1 * Ratio
            .FillEllipse(Brushes.White, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
        End With
    End Sub

    Private Sub DrawStone(ByVal PicG As Graphics, ByVal X As Single, ByVal Y As Single, ByVal Ratio As Single, ByVal NowDrawStone As StoneColor)
        Dim Center As PointF
        Dim Radius As Single = StoneRadius * Ratio
        Dim DrawStoneColor As Brush = Nothing

        Center.X = X * Ratio
        Center.Y = Y * Ratio

        Select Case NowDrawStone
            Case StoneColor.Red
                DrawStoneColor = Brushes.Red
            Case StoneColor.Yellow
                DrawStoneColor = Brushes.Yellow
        End Select

        With PicG
            .FillEllipse(Brushes.Gray, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
            Radius = StoneColorRadius * Ratio
            .FillEllipse(DrawStoneColor, Center.X - Radius, Center.Y - Radius, 2 * Radius, 2 * Radius)
        End With
    End Sub

    Private Sub DrawStone3D(ByVal PicG As Graphics, ByVal X As Single, ByVal Y As Single, ByVal NowDrawStone As StoneColor)
        Dim LowerCenter As PointF
        Dim Radius As Single = StoneRadius * Pic3DRatio
        Dim Thick As Single = 1 * Pic3DRatio
        Dim DrawStoneColor As Brush = Nothing
        'Dim ThickPen As New Pen(Color.Black)

        LowerCenter.X = X * Pic3DRatio
        LowerCenter.Y = Y * Pic3DRatio

        Select Case NowDrawStone
            Case StoneColor.Red
                DrawStoneColor = Brushes.Red
            Case StoneColor.Yellow
                DrawStoneColor = Brushes.Yellow
        End Select
        'ThickPen.Width = 3
        'Dim LineW As Single = SheetWidth * Pic3DRatio / 400
        'Dim LineH As Single = (FogToFog + FogToCenter + HouseRadius4 + EndLine) * Pic3DRatio / 400
        'ThickPen.ScaleTransform(LineW, LineH)

        With PicG
            '.DrawLine(ThickPen, LowerCenter.X - Radius, LowerCenter.Y, LowerCenter.X - Radius, LowerCenter.Y - Thick)
            '.DrawLine(ThickPen, LowerCenter.X + Radius, LowerCenter.Y, LowerCenter.X + Radius, LowerCenter.Y - Thick)
            .FillRectangle(Brushes.Gray, LowerCenter.X - Radius, LowerCenter.Y - Thick, 2 * Radius, Thick)
            '.DrawArc(ThickPen, LowerCenter.X - Radius, LowerCenter.Y - Radius, 2 * Radius, 2 * Radius, 0, 180)
            .FillEllipse(Brushes.Gray, LowerCenter.X - Radius, LowerCenter.Y - Radius, 2 * Radius, 2 * Radius)

            '.DrawEllipse(ThickPen, LowerCenter.X - Radius, LowerCenter.Y - Thick - Radius, 2 * Radius, 2 * Radius)
            .FillEllipse(Brushes.Gray, LowerCenter.X - Radius, LowerCenter.Y - Thick - Radius, 2 * Radius, 2 * Radius)
            Radius = StoneColorRadius * Pic3DRatio
            .FillEllipse(DrawStoneColor, LowerCenter.X - Radius, LowerCenter.Y - Thick - Radius, 2 * Radius, 2 * Radius)
        End With
    End Sub

    Private Sub PicTranslate(ByVal G As Graphics, ByVal X As Single, ByVal Y As Single, ByVal Ratio As Single)
        Dim mat As New Drawing2D.Matrix
        mat.Translate(X * Ratio, Y * Ratio)
        G.Transform = mat
        G.ScaleTransform(1, -1)
    End Sub

    ''' <summary>
    ''' PictureBoxScale
    ''' </summary>
    ''' <param name="Pic">gpPictureBox</param>
    ''' <param name="PicG">gpOtBbNNX</param>
    ''' <param name="FirstPointX">n_xW</param>
    ''' <param name="FirstPointY">n_yW</param>
    ''' <param name="EndPointX">I_xW</param>
    ''' <param name="EndPointY">I_yW</param>
    ''' <remarks></remarks>
    Private Sub PicScaling(ByVal Pic As PictureBox, ByVal PicG As Graphics, _
                           ByVal FirstPointX As Single, ByVal FirstPointY As Single, _
                           ByVal EndPointX As Single, ByVal EndPointY As Single)
        Dim PicWidth, PicHeight As Single
        Dim PicScaleX, PicScaleY As Single

        PicWidth = EndPointX - FirstPointX
        PicHeight = EndPointY - FirstPointY
        With Pic
            PicScaleX = .Width / PicWidth
            PicScaleY = .Height / PicHeight
        End With
        PicG.ScaleTransform(PicScaleX, PicScaleY)
        PicG.TranslateTransform(-FirstPointX, -FirstPointY)
    End Sub

    Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
        Dim Ret As MsgBoxResult
        Ret = MsgBox("Zbg܂B낵łH", MsgBoxStyle.OkCancel, "Q[Zbg")
        If Ret = MsgBoxResult.Ok Then
            Timer1.Enabled = False

            For i As Integer = 0 To UBound(Stone)
                With Stone(i)
                    .X = 0
                    .Y = 0
                    .Vx = 0
                    .Vy = 0
                    .IsOnSheet = False
                    .Color = i Mod 2
                End With
            Next i

            Impact = False
            ReDim StoneLocus(0), StoneLocus3D(0)
            NowTime = 0
            CaseNum = 0
            NowStoneIndex = 0
            NowEndIndex = 0
            RedTotal = 0
            YellowTotal = 0

            For i As Integer = 0 To 9
                RedScore(i) = 0
                YellowScore(i) = 0
                Dim lblName As String = "lblRedScore" & i + 1
                tblScore.Controls(lblName).Text = ""
                lblName = "lblYellowScore" & i + 1
                tblScore.Controls(lblName).Text = ""
            Next i
            lblRedScoreTotal.Text = ""
            lblYellowScoreTotal.Text = ""
            lblRedStone.Text = "l"
            lblYellowStone.Text = ""
            lblRedRemain.Text = "llllllll"
            lblYellowRemain.Text = "llllllll"

            PicAllView.Invalidate()
            PicHouse.Invalidate()
            Pic3D.Invalidate()

        End If
    End Sub

    Private Sub txtName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtName2.Click, txtName1.Click
        DirectCast(sender, TextBox).SelectAll()
    End Sub
End Class
